sys=tf([1 -2],[1 0 1]);
[A,B,C,D]=ssdata(ss(sys));

R=1;
Q={};
Q{1}=50*eye(size(A,1));
Q{2}=1*eye(size(A,1));
c={'r','b'};

figure(1)
clf
for i=1:2,
   K=-lqr(A,B,Q{i},R);
   clsys=ss(A+B*K,B,C,D);
   x0=[.95 .23]';
   [y,t,x]=initial(clsys,x0,4);
   
   subplot(211)
   h=plot(t,y,c{i});
   set(h,'linewidth',1.5);
   hold on
   h=title('state x(t)');
   set(h,'FontSize',20,'Fontname','cmr10');
   if i==1,
      grid
   end
   
   subplot(212)
   h=plot(t,x*K',c{i});
   set(h,'linewidth',1.5);
   hold on
   h=title('input u(t)');
   set(h,'FontSize',20,'Fontname','cmr10');
   if i==1,
      grid
   end
end

figure(2)
clf
[x1,x2]=meshgrid(-1:.5:1,-1:.5:1);
for i=1:size(x1,1),
   for j=1:size(x1,2);
      x0=[x1(i,j),x2(i,j)]';
      [y,t,x]=initial(clsys,x0,4);
      h=plot(x(:,1),x(:,2),'b');
      set(h,'linewidth',1.5);
      hold on
   end
end
grid


figure(3)
clf
[y,t,x]=initial(clsys,[.5 .9]',4);

subplot(211)
h=plot(t,y,'b');
hold on
set(h,'linewidth',1.5);
n=round(length(t)/2);
h=plot(t(n),y(n),'*g');
set(h,'linewidth',1.5);
h=plot(t(n:end),y(n:end),'r');
set(h,'linewidth',3);
hold off
grid
h=title('optimal state x^*(t)');
set(h,'FontSize',20,'Fontname','cmr10');

subplot(212)
h=plot(t,x*K','b');
hold on
set(h,'linewidth',1.5);
h=plot(t(n),x(n,:)*K','*g');
set(h,'linewidth',1.5);
h=plot(t(n:end),x(n:end,:)*K','r');
set(h,'linewidth',3);
hold off
grid
h=title('optimal input u^*(t)');
set(h,'FontSize',20,'Fontname','cmr10');


A=[1 1;0 1];
B=[0;1];
C=[1 0];
D=0;
int=ss(A,B,C,D,1);

Q=C'*C;
clear R
R{1}=0.1;
R{2}=10;
R{3}=1000;
T=20;

c={'r','b','g'};
s={'o','d','s'};
x0=[1 0]';

figure(3)
clf
for i=1:3,
   K=-dlqr(A,B,Q,R{i});
   clsys=ss(A+B*K,B,C,D,1);
   [y,t,x]=initial(clsys,x0,T);
   
   subplot(211)
   h=plot(t,y,c{i});
   set(h,'linewidth',1.5);
   hold on
   h=plot(t,y,[s{i} c{i}]);
   set(h,'linewidth',1.5);
   h=title('output y(k)');
   set(h,'FontSize',20,'Fontname','cmr10');
   if i==1,
      grid
   end
   
   subplot(212)
   h=plot(t,x*K',c{i});
   set(h,'linewidth',1.5);
   hold on
   h=plot(t,x*K',[s{i} c{i}]);
   set(h,'linewidth',1.5);
   h=title('input u(k)');
   set(h,'FontSize',20,'Fontname','cmr10');
   if i==1,
      grid
   end
end

% LQR with tracking
Q=eye(2);
R=1;
AA=[A zeros(2,1);C 1]; % system augmented with q(k+1)=q(k)+y(k)
BB=[B;0];
CC=[C 0];
DD=0;
KK=-dlqr(AA,BB,blkdiag(Q,1),R);  % u=K[x;q]
x0=[0;0]';

H=inv([C 1]*inv(eye(3)-AA-BB*KK)*BB);
